var serverSystem = server.registerSystem(0, 0);


serverSystem.initialize = function () {
    const scriptLoggerConfig = serverSystem.createEventData("minecraft:script_logger_config");
    scriptLoggerConfig.data.log_errors = true;
    scriptLoggerConfig.data.log_information = true;
    scriptLoggerConfig.data.log_warnings = true;
    serverSystem.broadcastEvent("minecraft:script_logger_config", scriptLoggerConfig);
    serverSystem.players = {};
    serverSystem.listenForEvent("minecraft:player_placed_block", eventData => serverSystem.blockPlace(eventData));
};


serverSystem.blockPlace = function (eventData) {
    //player var is the name of the player
    let player = String(serverSystem.getComponent(eventData.data.player, "minecraft:nameable").data.name);
    let blockPos = eventData.data.block_position;
    let heldItem = serverSystem.getComponent(eventData.data.player, "minecraft:hand_container").data[0].item

    if (heldItem == "block:fillair" || heldItem == "block:setcoords" || heldItem == "block:hollow") {
        serverSystem.executeCommand("/setblock " + blockPos.x + " " + blockPos.y + " " + blockPos.z + " air 0", () => { });
    }

    if (!(player in serverSystem.players)) {
        serverSystem.players[player] = {
            "fp": [],
            "sp": [],
            "mode": "Box"
        };
    }

    //changes modes
    if (heldItem == "block:hollow") {
        if (serverSystem.players[player].mode == "Box") {
            serverSystem.players[player].mode = "Filled Box";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });
        } else if (serverSystem.players[player].mode == "Filled Box") {
            serverSystem.players[player].mode = "Cylindrical";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });
        } else if (serverSystem.players[player].mode == "Cylindrical") {
            serverSystem.players[player].mode = "Spherical";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });
        } else if (serverSystem.players[player].mode == "Spherical") {
            serverSystem.players[player].mode = "Box";
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§a§lPlace mode is set to ' + serverSystem.players[player].mode + '"}]}', () => { });
        } else {
            serverSystem.executeCommand('/tellraw ' + player + ' {"rawtext":[{"text":"§c§lWorldEdit encountered an unknown error! Please restart the world."}]}', () => { });
        }

        serverSystem.players[player].fp = [];
        serverSystem.players[player].sp = [];

        return null
    }

    if (heldItem == "block:setcoords") {
        if (serverSystem.players[player].fp.length != 0 && serverSystem.players[player].sp.length != 0) {
            //resets coords
            serverSystem.players[player].fp = [];
            serverSystem.players[player].sp = [];
                serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§c§lPositions cleared"}]}', () => { });
            return null
        } else if (serverSystem.players[player].fp.length == 0) {
            //set first coords
            serverSystem.players[player].fp = [blockPos.x, blockPos.y, blockPos.z];


            switch (serverSystem.players[player].mode) {
                case "Box":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§lFirst corner set"}]}', ()=>{});
                    break;
                case "Filled Box":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§lFirst corner set"}]}', ()=>{});
                    break
                case "Cylindrical":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§lBase/center set"}]}', ()=>{});
                    break
                case "Spherical":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§lCentroid set"}]}', ()=>{});
                    break
            }
            
            return null;
        } else if (serverSystem.players[player].sp.length == 0) {
            //set the second coords
            serverSystem.players[player].sp = [blockPos.x, blockPos.y, blockPos.z];

            switch (serverSystem.players[player].mode) {
                case "Box":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§lSecond corner set"}]}', ()=>{});
                    break;
                case "Filled Box":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§lSecond corner set"}]}', ()=>{});
                    break;
                case "Cylindrical":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§lRadius/height set"}]}', ()=>{});
                    break;
                case "Spherical":
                    serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§b§lRadius set"}]}', ()=>{});
                    break;
            }
            return null;
        }
    }


    //go on to filling methods if there coords arent full and the block placed wasnt one of the three
    if (serverSystem.players[player].fp.length != 0 && serverSystem.players[player].sp.length != 0) {

        if (serverSystem.players[player].mode == "Box") {
            //do the fill then calculate the block array if needed
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lPerforming fill for Box method"}]}', () => { });

            let viewingBlocksData = this.getComponent(serverSystem.getBlock(serverSystem.getComponent(eventData.data.player, "minecraft:tick_world").data.ticking_area, blockPos.x, blockPos.y, blockPos.z), "minecraft:blockstate");

            serverSystem.executeCommand("/fill " + String(serverSystem.players[player].fp[0]) + " " + String(serverSystem.players[player].fp[1]) + " " + String(serverSystem.players[player].fp[2]) + " " + String(serverSystem.players[player].sp[0]) + " " + String(serverSystem.players[player].sp[1]) + " " + String(serverSystem.players[player].sp[2]) + " " + serverSystem.filterNamespace(heldItem) + " 0 outline", (callback) => {
                //check if blockstate needs to be replaced.


                //this is the blockstate of the block that was placed down (used to fill). the other is for the 2nd corner.
                //let viewingBlocksData = this.getComponent(serverSystem.getBlock(serverSystem.getComponent(eventData.data.player, "minecraft:tick_world").data.ticking_area, blockPos.x, blockPos.y, blockPos.z), "minecraft:blockstate");

                //gets blockstate of the block for the 2nd corner filled.
                let firstFillBlock = this.getComponent(serverSystem.getBlock(serverSystem.getComponent(eventData.data.player, "minecraft:tick_world").data.ticking_area, serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]), "minecraft:blockstate");

                if (JSON.stringify(viewingBlocksData) !== JSON.stringify(firstFillBlock)) {
                    //get an array of all the blocks and input them to the replace blockstate method.


                    function getHollowObj(cor1, cor2) {
                        let faces = [];
                        faces.push([[cor1[0], cor1[1], cor1[2]], [cor2[0], cor1[1], cor2[2]]]);
                        faces.push([[cor1[0], cor2[1], cor1[2]], [cor2[0], cor2[1], cor2[2]]]);
                        faces.push([[cor1[0], cor1[1], cor1[2]], [cor2[0], cor2[1], cor1[2]]]);
                        faces.push([[cor1[0], cor1[1], cor2[2]], [cor2[0], cor2[1], cor2[2]]]);
                        faces.push([[cor1[0], cor1[1], cor1[2]], [cor1[0], cor2[1], cor2[2]]]);
                        faces.push([[cor2[0], cor1[1], cor1[2]], [cor2[0], cor2[1], cor2[2]]]);

                        faces = faces.map(serverSystem.getBlocksInbetween);

                        let wholeArray = [];
                        for (let i = 0; i < faces.length; i++) {
                            for (let j = 0; j < faces[i].length; j++) {
                                wholeArray.push(faces[i][j])
                            }
                        }
                        return wholeArray;
                    }

                    //now input to blockstate method

                    serverSystem.replaceBlockState(getHollowObj([serverSystem.players[player].fp[0], serverSystem.players[player].fp[1], serverSystem.players[player].fp[2]], [serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]]), viewingBlocksData, eventData.data.player)

                }
                serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lDone! Filled '+callback.data.fillCount+' blocks."}]}', () => { });




                serverSystem.players[player].fp = [];
                serverSystem.players[player].sp = [];
            });
            return null;

        }


        if (serverSystem.players[player].mode == "Filled Box") {
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lPerforming fill for Filled Box method"}]}', () => { });
            let viewingBlocksData = this.getComponent(serverSystem.getBlock(serverSystem.getComponent(eventData.data.player, "minecraft:tick_world").data.ticking_area, blockPos.x, blockPos.y, blockPos.z), "minecraft:blockstate");
            serverSystem.executeCommand("/fill " + String(serverSystem.players[player].fp[0]) + " " + String(serverSystem.players[player].fp[1]) + " " + String(serverSystem.players[player].fp[2]) + " " + String(serverSystem.players[player].sp[0]) + " " + String(serverSystem.players[player].sp[1]) + " " + String(serverSystem.players[player].sp[2]) + " " + serverSystem.filterNamespace(heldItem) + " 0", (callback) => {
                let firstFillBlock = this.getComponent(serverSystem.getBlock(serverSystem.getComponent(eventData.data.player, "minecraft:tick_world").data.ticking_area, serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]), "minecraft:blockstate");
                if (JSON.stringify(viewingBlocksData) !== JSON.stringify(firstFillBlock)) {


                

                    serverSystem.replaceBlockState(serverSystem.getBlocksInbetween([[serverSystem.players[player].fp[0], serverSystem.players[player].fp[1], serverSystem.players[player].fp[2]], [serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]]]), viewingBlocksData, eventData.data.player)
                    //do code to replace blockState
                }
                serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lDone! Filled ' + callback.data.fillCount + ' block(s)."}]}', () => { });

                serverSystem.players[player].fp = [];
                serverSystem.players[player].sp = [];


            });

        }


        if (serverSystem.players[player].mode == "Cylindrical") {
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lPerforming fill for Cylindrical method"}]}', () => { });
            let viewingBlocksData = this.getComponent(serverSystem.getBlock(serverSystem.getComponent(eventData.data.player, "minecraft:tick_world").data.ticking_area, blockPos.x, blockPos.y, blockPos.z), "minecraft:blockstate");



            function getCircle(cor1, cor2) {
                let radius = Math.sqrt((cor2[0] - cor1[0]) ** 2 + (cor2[2] - cor1[2]) ** 2);
                let initialHeight = cor2[1] - cor1[1];
                let coordSet = new Set();
                let ct = Math.PI;

                while (true) {
                    coordSet.add([(parseInt(Math.sin(ct) * radius) + cor1[0]), cor1[1], (parseInt(Math.cos(ct) * radius) + cor1[2])])
                    ct += 0.25 / parseFloat(radius)
                    if (ct > Math.PI * 3) {
                        ct = Math.PI
                        break
                    }

                }
                coordSet = Array.from(coordSet)
                let initLen = coordSet.length
                for (i = 0; i < Math.abs(initialHeight); i++) {
                    if (initialHeight < 0) {
                        for (j = 0; j < initLen; j++) {
                            coordSet.push([coordSet[j][0], coordSet[j][1] + ((i * -1)-1), coordSet[j][2]])
                        }


                    } else if (initialHeight > 0) {
                        for (j = 0; j <= initLen; j++) {
                            coordSet.push([coordSet[j][0], coordSet[j][1] + i+1, coordSet[j][2]])
                        }
                    } else {
                        break
                    }
                }

                return coordSet
            }

            let cylinderArray = getCircle([serverSystem.players[player].fp[0], serverSystem.players[player].fp[1], serverSystem.players[player].fp[2]], [serverSystem.players[player].sp[0], serverSystem.players[player].sp[1], serverSystem.players[player].sp[2]]);


            let iterations = 0;
            for (let i = 0; i < cylinderArray.length; i++) {
                serverSystem.executeCommand("/setblock " + String(cylinderArray[i][0]) + " " + String(cylinderArray[i][1]) + " " + String(cylinderArray[i][2]) + " " + serverSystem.filterNamespace(heldItem) + " 0", (callback) => {
                    iterations += 1; if (iterations == cylinderArray.length) {
                        let firstFillBlock = this.getComponent(serverSystem.getBlock(serverSystem.getComponent(eventData.data.player, "minecraft:tick_world").data.ticking_area, cylinderArray[cylinderArray.length - 1][0], cylinderArray[cylinderArray.length - 1][1], cylinderArray[cylinderArray.length - 1][2]), "minecraft:blockstate");
                        if (JSON.stringify(viewingBlocksData) !== JSON.stringify(firstFillBlock)) {

                            serverSystem.replaceBlockState(cylinderArray, viewingBlocksData, eventData.data.player)
                        }


                        serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§a§lDone! Filled ' + String(cylinderArray.length) + ' block(s)."}]}', () => { });
                        serverSystem.players[player].fp = [];
                        serverSystem.players[player].sp = [];
                    }
                });
            }
            

        }

        if (serverSystem.players[player].mode == "Spherical") {
            serverSystem.executeCommand("/tellraw " + player + ' {"rawtext":[{"text":"§6§lSorry but this feature is unavailable at the moment. Check back on mcpedl for an update later"}]}', () => { });
            serverSystem.players[player].fp = [];
            serverSystem.players[player].sp = [];
        }


    }




    

}


serverSystem.getBlocksInbetween = function(pair) {
    let increment1 = 0;
    let increment2 = 0;
    let increment3 = 0;
    if (pair[1][0] - pair[0][0] < 0) {
        increment1 -= 1;
    } else {
        increment1 += 1;
    }
    if (pair[1][1] - pair[0][1] < 0) {
        increment2 -= 1;
    } else {
        increment2 += 1;
    }
    if (pair[1][2] - pair[0][2] < 0) {
        increment3 -= 1;
    }
    else {
        increment3 += 1;
    }
    returnList = [];
    for (let i = pair[0][0]; i != pair[1][0] + increment1; i += increment1) {
        for (let j = pair[0][1]; j != pair[1][1] + increment2; j += increment2) {
            for (let k = pair[0][2]; k != pair[1][2] + increment3; k += increment3) {
                returnList.push([i, j, k])
            };
        };
    };
    return returnList;
};


serverSystem.filterNamespace = function (id) {
    id = id.replace("block:fillair", "air");
    id = id.replace("minecraft:concrete_powder", "minecraft:concretepowder");
    id = id.replace("minecraft:comparator", "minecraft:unpowered_comparator");
    id = id.replace("minecraft:repeater", "minecraft:unpowered_repeater");
    if (id == "minecraft:redstone") {
        id = "minecraft:redstone_wire";
    }
    id = id.replace("minecraft:", "");
    return id
}


serverSystem.replaceBlockState = function (blocksArray, blockState, eventPlayer) {

    for (let i=0; i < blocksArray.length; i++) {

        serverSystem.applyComponentChanges(serverSystem.getBlock(serverSystem.getComponent(eventPlayer, "minecraft:tick_world").data.ticking_area, blocksArray[i][0], blocksArray[i][1], blocksArray[i][2]), blockState);

    }
}



serverSystem.logToAll = function (msg) {
    let myMessage = serverSystem.createEventData("minecraft:display_chat_event");
    myMessage.data.message = msg;
    serverSystem.broadcastEvent("minecraft:display_chat_event", myMessage);
};
